unit Comms;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TCommsForm = class(TForm)
    GroupBox1: TGroupBox;
    ComboBox1: TComboBox;
    Label1: TLabel;
    ChkPort: TCheckBox;
    CmdExit: TButton;
    procedure FormCreate(Sender: TObject);
    procedure CmdExitClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CommsForm: TCommsForm;

implementation

uses Main;

{$R *.DFM}

procedure TCommsForm.FormCreate(Sender: TObject);
begin
        ChkPort.Checked:=bSerialInit;
        Combobox1.Clear;
        Combobox1.Items.Add('1');
        Combobox1.Items.Add('2');
        Combobox1.Items.Add('3');
        Combobox1.Items.Add('4');
        Combobox1.Items.Add('5');
        Combobox1.Items.Add('6');
        Combobox1.Items.Add('7');
        Combobox1.Items.Add('8');
        Combobox1.Items.Add('9');
        Combobox1.Items.Add('10');
        Combobox1.Text:=IntToStr(iComport);

end;

procedure TCommsForm.CmdExitClick(Sender: TObject);
var
   sStr:String;
   i,Par,Stp:Integer;
begin
     MainForm.CloseComm(iComPort);
     iComPort:=StrToInt(ComboBox1.Text);
     iBaudRate:=9600;
     iDataBits:=8;
     sParity:='N';
     If sParity='N' then Par:=0;
     If sParity='E' then Par:=1;
     If sParity='O' then Par:=2;
     iStopBits:=1;
     If iStopBits=1 then Stp:=1;
     If iStopBits=2 then Stp:=2;
     MainForm.OpenComm(iComPort,1024,1024,iBaudRate,iDataBits,Par,Stp);
     if ChkPort.Checked=True then
        begin
        MainForm.PortActivate();
        bSerialInit:=True;
        end
     else
        begin
        bSerialInit:=False;
        end;
     Close;
end;

end.
