unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Menus, Math, ExtCtrls, ZylSerialPort;

type
  TMainForm = class(TForm)
    ComboBox1: TComboBox;
    Label50: TLabel;
    StringGrid1: TStringGrid;
    All1: TButton;
    All2: TButton;
    All3: TButton;
    All4: TButton;
    All5: TButton;
    None1: TButton;
    All6: TButton;
    All7: TButton;
    All8: TButton;
    All9: TButton;
    All10: TButton;
    All11: TButton;
    All12: TButton;
    All13: TButton;
    All14: TButton;
    All15: TButton;
    All16: TButton;
    All17: TButton;
    All18: TButton;
    All19: TButton;
    All20: TButton;
    MainMenu1: TMainMenu;
    F1: TMenuItem;
    New1: TMenuItem;
    Load1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    Comms1: TMenuItem;
    TxtPer1: TEdit;
    TxtPer2: TEdit;
    TxtPer3: TEdit;
    TxtPer4: TEdit;
    TxtPer5: TEdit;
    TxtPer6: TEdit;
    TxtPer7: TEdit;
    TxtPer8: TEdit;
    TxtPer9: TEdit;
    TxtPer10: TEdit;
    TxtPer11: TEdit;
    TxtPer12: TEdit;
    TxtPer13: TEdit;
    TxtPer14: TEdit;
    TxtPer15: TEdit;
    TxtPer16: TEdit;
    TxtPer17: TEdit;
    TxtPer18: TEdit;
    TxtPer19: TEdit;
    TxtPer20: TEdit;
    None2: TButton;
    None3: TButton;
    None4: TButton;
    None5: TButton;
    None6: TButton;
    None7: TButton;
    None8: TButton;
    None9: TButton;
    None10: TButton;
    None11: TButton;
    None12: TButton;
    None13: TButton;
    None14: TButton;
    None15: TButton;
    None16: TButton;
    None17: TButton;
    None18: TButton;
    None19: TButton;
    None20: TButton;
    CmdNext: TButton;
    CmdPrev: TButton;
    CmdInsert: TButton;
    CmdDelete: TButton;
    CmdStart: TButton;
    CmdStop: TButton;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Serial1: TZylSerialPort;
    Timer1: TTimer;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    StringGrid2: TStringGrid;
    TxtBox101: TEdit;
    GroupBox2: TGroupBox;
    TxtRepeat: TEdit;
    Label1: TLabel;
    Label5: TLabel;
    TxtNoRepeats: TEdit;
    Label6: TLabel;
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure ReadDisplay();
    procedure DisplayRelays();
    procedure All1Click(Sender: TObject);
    procedure All2Click(Sender: TObject);
    procedure All3Click(Sender: TObject);
    procedure All4Click(Sender: TObject);
    procedure All5Click(Sender: TObject);
    procedure All6Click(Sender: TObject);
    procedure All7Click(Sender: TObject);
    procedure All8Click(Sender: TObject);
    procedure All9Click(Sender: TObject);
    procedure All10Click(Sender: TObject);
    procedure All11Click(Sender: TObject);
    procedure All12Click(Sender: TObject);
    procedure All13Click(Sender: TObject);
    procedure All14Click(Sender: TObject);
    procedure All15Click(Sender: TObject);
    procedure None1Click(Sender: TObject);
    procedure None2Click(Sender: TObject);
    procedure None3Click(Sender: TObject);
    procedure None4Click(Sender: TObject);
    procedure None5Click(Sender: TObject);
    procedure None6Click(Sender: TObject);
    procedure CmdNextClick(Sender: TObject);
    procedure CmdPrevClick(Sender: TObject);
    procedure CmdInsertClick(Sender: TObject);
    procedure CmdDeleteClick(Sender: TObject);
    procedure CmdStartClick(Sender: TObject);
    procedure CmdStopClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure Exit1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    function OpenComm(ID,InQueue, OutQueue, Baud,iDB,Par,Stp: LongInt): Boolean;
    procedure PortActivate;
    procedure CloseComm(ID:Integer);
    function SendCommStr(S: String): Integer;
    procedure Comms1Click(Sender: TObject);
    procedure StringGrid2DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure Load1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure All16Click(Sender: TObject);
    procedure All17Click(Sender: TObject);
    procedure All18Click(Sender: TObject);
    procedure All19Click(Sender: TObject);
    procedure All20Click(Sender: TObject);
    procedure None16Click(Sender: TObject);
    procedure None17Click(Sender: TObject);
    procedure None18Click(Sender: TObject);
    procedure None19Click(Sender: TObject);
    procedure None20Click(Sender: TObject);
    procedure None7Click(Sender: TObject);
    procedure None8Click(Sender: TObject);
    procedure None9Click(Sender: TObject);
    procedure None10Click(Sender: TObject);
    procedure None11Click(Sender: TObject);
    procedure None12Click(Sender: TObject);
    procedure None13Click(Sender: TObject);
    procedure None14Click(Sender: TObject);
    procedure None15Click(Sender: TObject);


  private
    { Private declarations }
  public
    { Public declarations }
  end;
const
 MaxIndex=100;
var
  MainForm: TMainForm;
  iStart:Integer;
  iRelays: Array[1..100] of Integer;
  IInterval: Array[1..MaxIndex] of Integer;
  ITime: Integer;
  IRunNo: Integer;
  bRun: Boolean;
  iComport:Integer;
  bSerialInit:Boolean;
  iBaudRate:Integer;
  iDataBits:Integer;
  sParity:String;
  iStopBits:Integer;
  iRepeats, iRepeatsToGo, iNoRepeats:Integer;


implementation

uses Comms;

{$R *.DFM}

procedure TMainForm.StringGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
var
    i,j,k,m:integer;
    iBit,iMask:integer;
begin
        i:=ACol;
        j:=ARow;
        m:=iStart;
        i:=i-1;
        iMask:=1;
        For k:=1 to i do
            begin
            iMask:=iMask * 2;
            end;
        iBit:=iRelays[j+m-1] and iMask;
        if (iBit=0) then
            begin
            iRelays[j+m-1]:=iRelays[j+m-1] or iMask;
            end
        else
            begin
            iMask:= 65535 xor iMask;
            iRelays[j+m-1]:=iRelays[j+m-1] and iMask;
            end;
        DisplayRelays();

end;


procedure TMainForm.FormCreate(Sender: TObject);
var
    i,j:integer;
    iTim: integer;
begin
    iStart:=1;
    StringGrid1.Cells[0,0]:='STEP';
    j:=iStart;
    iTim:=1;
    {Label the Grid}
       for i:=1 to 20 do
           begin
           StringGrid1.Cells[0,i]:=IntToStr(i);
           iRelays[i]:=0; {i;}
           IInterval[i]:=0; { iTim;}
           iTim:=iTim+1;
           end;
       for i:=1 to 8 do
           begin
           StringGrid1.Cells[i,0]:=IntToStr(i);
           end;
    DisplayRelays();
      iComport:=1;

end;

procedure TMainForm.ReadDisplay();
var
    i,j,k:integer;
    sFlt: Array[1..20] of Real;
    sStr:String;
begin
    i:=iStart;
    sFlt[1]:=StrToFloat(TxtPer1.Text);
    sFlt[2]:=StrToFloat(TxtPer2.Text);
    sFlt[3]:=StrToFloat(TxtPer3.Text);
    sFlt[4]:=StrToFloat(TxtPer4.Text);
    sFlt[5]:=StrToFloat(TxtPer5.Text);
    sFlt[6]:=StrToFloat(TxtPer6.Text);
    sFlt[7]:=StrToFloat(TxtPer7.Text);
    sFlt[8]:=StrToFloat(TxtPer8.Text);
    sFlt[9]:=StrToFloat(TxtPer9.Text);
    sFlt[10]:=StrToFloat(TxtPer10.Text);
    sFlt[11]:=StrToFloat(TxtPer11.Text);
    sFlt[12]:=StrToFloat(TxtPer12.Text);
    sFlt[13]:=StrToFloat(TxtPer13.Text);
    sFlt[14]:=StrToFloat(TxtPer14.Text);
    sFlt[15]:=StrToFloat(TxtPer15.Text);
    sFlt[16]:=StrToFloat(TxtPer16.Text);
    sFlt[17]:=StrToFloat(TxtPer17.Text);
    sFlt[18]:=StrToFloat(TxtPer18.Text);
    sFlt[19]:=StrToFloat(TxtPer19.Text);
    sFlt[20]:=StrToFloat(TxtPer20.Text);
    For k:=1 to 20 do
        begin
        sFlt[k]:=sFlt[k] * 10;
    {sFlt:=Int(sFlt);}
        if (sFlt[k]>=0.0) and (sFlt[k]<=30000) then iInterval[k+iStart-1]:=Trunc(sFlt[k]);
        end;


end;



procedure TMainForm.DisplayRelays();
var
    i,j,k:integer;
    iBit, iMask:integer;
    sFlt: Array[1..20] of Real;

begin
    StringGrid1.Cells[0,0]:='STEP';
    k:=iStart;
    {Label the Grid}
       for i:=1 to 20 do
           begin
           StringGrid1.Cells[0,i]:=IntToStr(k+i-1);
           end;
       for i:=1 to 8 do
           begin
           StringGrid1.Cells[i,0]:=IntToStr(i);
           end;
      iMask:=1;
      For i:=1 to 20 do
           begin
           iMask:=1;
           For j:=1 to 8 do
                begin
                StringGrid1.Font.Color:=clBlack;
                iBit:=iRelays[i+iStart-1] and iMask;
                if (iBit=0) then
                    begin
                    StringGrid1.Cells[j,i]:='OFF';
                    end
                else
                    begin
                    StringGrid1.Cells[j,i]:='ON';
                    end;
                iMask:=iMask * 2;
                end;
           end;
    For k:=1 to 20 do
        begin
        sFlt[k]:=iInterval[k+iStart-1];
        sFlt[k]:=sFlt[k] / 10;
        end;

    TxtPer1.Text:=Format('%8.1f',[sFlt[1]]);
    TxtPer2.Text:=Format('%8.1f',[sFlt[2]]);
    TxtPer3.Text:=Format('%8.1f',[sFlt[3]]);
    TxtPer4.Text:=Format('%8.1f',[sFlt[4]]);
    TxtPer5.Text:=Format('%8.1f',[sFlt[5]]);
    TxtPer6.Text:=Format('%8.1f',[sFlt[6]]);
    TxtPer7.Text:=Format('%8.1f',[sFlt[7]]);
    TxtPer8.Text:=Format('%8.1f',[sFlt[8]]);
    TxtPer9.Text:=Format('%8.1f',[sFlt[9]]);
    TxtPer10.Text:=Format('%8.1f',[sFlt[10]]);
    TxtPer11.Text:=Format('%8.1f',[sFlt[11]]);
    TxtPer12.Text:=Format('%8.1f',[sFlt[12]]);
    TxtPer13.Text:=Format('%8.1f',[sFlt[13]]);
    TxtPer14.Text:=Format('%8.1f',[sFlt[14]]);
    TxtPer15.Text:=Format('%8.1f',[sFlt[15]]);
    TxtPer16.Text:=Format('%8.1f',[sFlt[16]]);
    TxtPer17.Text:=Format('%8.1f',[sFlt[17]]);
    TxtPer18.Text:=Format('%8.1f',[sFlt[18]]);
    TxtPer19.Text:=Format('%8.1f',[sFlt[19]]);
    TxtPer20.Text:=Format('%8.1f',[sFlt[20]]);




end;




procedure TMainForm.All1Click(Sender: TObject);
var
    i,j:integer;
begin
    iRelays[iStart]:=255;
    DisplayRelays();
end;

procedure TMainForm.All2Click(Sender: TObject);
begin
    iRelays[iStart+1]:=255;
    DisplayRelays();

end;

procedure TMainForm.All3Click(Sender: TObject);
begin
    iRelays[iStart+2]:=255;
    DisplayRelays();

end;

procedure TMainForm.All4Click(Sender: TObject);
begin
    iRelays[iStart+3]:=255;
    DisplayRelays();

end;

procedure TMainForm.All5Click(Sender: TObject);
begin
    iRelays[iStart+4]:=255;
    DisplayRelays();

end;

procedure TMainForm.All6Click(Sender: TObject);
begin
    iRelays[iStart+5]:=255;
    DisplayRelays();

end;

procedure TMainForm.All7Click(Sender: TObject);
begin
    iRelays[iStart+6]:=255;
    DisplayRelays();

end;

procedure TMainForm.All8Click(Sender: TObject);
begin
    iRelays[iStart+7]:=255;
    DisplayRelays();

end;

procedure TMainForm.All9Click(Sender: TObject);
begin
    iRelays[iStart+8]:=255;
    DisplayRelays();

end;

procedure TMainForm.All10Click(Sender: TObject);
begin
    iRelays[iStart+9]:=255;
    DisplayRelays();

end;

procedure TMainForm.All11Click(Sender: TObject);
begin
    iRelays[iStart+10]:=255;
    DisplayRelays();

end;

procedure TMainForm.All12Click(Sender: TObject);
begin
    iRelays[iStart+11]:=255;
    DisplayRelays();

end;

procedure TMainForm.All13Click(Sender: TObject);
begin
    iRelays[iStart+12]:=255;
    DisplayRelays();

end;

procedure TMainForm.All14Click(Sender: TObject);
begin
    iRelays[iStart+13]:=255;
    DisplayRelays();

end;

procedure TMainForm.All15Click(Sender: TObject);
begin
    iRelays[iStart+14]:=255;
    DisplayRelays();

end;

procedure TMainForm.None1Click(Sender: TObject);
begin
    iRelays[iStart]:=0;
    DisplayRelays();

end;

procedure TMainForm.None2Click(Sender: TObject);
begin
    iRelays[iStart+1]:=0;
    DisplayRelays();

end;

procedure TMainForm.None3Click(Sender: TObject);
begin
    iRelays[iStart+2]:=0;
    DisplayRelays();

end;

procedure TMainForm.None4Click(Sender: TObject);
begin
    iRelays[iStart+3]:=0;
    DisplayRelays();

end;

procedure TMainForm.None5Click(Sender: TObject);
begin
    iRelays[iStart+4]:=0;
    DisplayRelays();

end;

procedure TMainForm.None6Click(Sender: TObject);
begin
    iRelays[iStart+5]:=0;
    DisplayRelays();

end;

procedure TMainForm.CmdNextClick(Sender: TObject);
begin
        ReadDisplay();
        iStart:=iStart+10;
        if iStart>90 then iStart:=iStart-10;
        DisplayRelays();
end;

procedure TMainForm.CmdPrevClick(Sender: TObject);
begin
        ReadDisplay();
        iStart:=iStart-10;
        if iStart<0 then iStart:=1;
        DisplayRelays();

end;

procedure TMainForm.CmdInsertClick(Sender: TObject);
var
    I, J :Integer;
    InputString:String;
begin
        InputString := InputBox('Insert Step','Insert before step ','' );
        If InputString <> '' Then
            begin
            I := StrToInt(InputString);
            If I < MaxIndex Then
                begin
                For J := MaxIndex downto I do
                    begin
                    iRelays[J + 1] := IRelays[ J];
                    IInterval[J + 1] := IInterval[ J];
                    end;
                J := I;
                IRelays[ J] := 0;
                IInterval[J] := 0;
                DisplayRelays();
                end;
            end;

end;

procedure TMainForm.CmdDeleteClick(Sender: TObject);
var
    I, J :Integer;
    InputString:String;
begin
        InputString := InputBox('Delete Step','Delete step number ','' );
        If InputString <> '' Then
            begin
            I := StrToInt(InputString);
            If I < MaxIndex Then
                begin
                For J := I to MaxIndex do
                    begin
                    iRelays[J] := IRelays[ J+1];
                    IInterval[J] := IInterval[ J+1];
                    end;
                J := I;
                IRelays[ MaxIndex] := 0;
                IInterval[ MaxIndex] := 0;
                DisplayRelays();
                end;
            end;

end;

procedure TMainForm.CmdStartClick(Sender: TObject);
var
    IOut:Integer;
    ss:String;
begin
    iRepeats:=StrToInt(TxtRepeat.Text);
    iRepeatsToGo:=iRepeats;
    ReadDisplay();
    bRun := True;
    IRunNo := 1;
    iNoRepeats:=0;
    TxtNoRepeats.Text:=IntToStr(iNoRepeats);
    ITime := IInterval[IRunNo];
    Iout:=IRelays[IRunNo]; 
    ss:= IntToStr(Iout);
    SendCommStr('@00 WR ' + ss + Chr(13));


end;

procedure TMainForm.CmdStopClick(Sender: TObject);
begin
    bRun := False;
    IRunNo := 0;
    SendCommStr('@00 WR 00' + Chr(13));

end;

procedure TMainForm.Timer1Timer(Sender: TObject);
var
    sFlt:Single;
    i,j,k:Integer;
    iMask,IOut:Integer;
    iBit:Integer;
    ss:string;
begin
    If bRun = True Then
        begin
        If ITime > 0 Then
            begin
            ITime:=ITime-1;
            Iout := IRelays[IRunNo];
            end
        Else
            begin
            IRunNo := IRunNo + 1;
            If IRunNo > MaxIndex Then
                begin
                IRunNo := 1;
                end;

            ITime := IInterval[IRunNo];
            sFlt:=ITime;
            TxtBox101.Text := Format('%8.1f',[sFlt]);
            If (ITime = 0) Then
                begin
                iNoRepeats:=iNoRepeats+1;
                TxtNoRepeats.Text:=IntToStr(iNoRepeats);
                if iRepeats>0 then
                    begin
                    if iRepeatsToGo>1 then
                        begin
                        iRepeatsToGo:=iRepeatsToGo-1;
                        IRunNo := 1;
                        end
                    else
                        begin
                        IRunNo:=1;
                        bRun:=False;
                        end;
                    end
                else
                    begin
                    IRunNo := 1;
                    end;
                end;
            if (bRun=True) then
                begin
                Iout := IRelays[IRunNo];
                end
            else
                begin
                IOut:=0;
                end;
            ITime := IInterval[IRunNo];
            ss:= IntToStr(Iout);
            SendCommStr('@00 WR ' + ss + Chr(13));
            ITime := ITime - 1;
            end;
        {Label the Grid}
        StringGrid2.Cells[0,0]:='Step';
         StringGrid2.Cells[0,1]:=IntToStr(iRunNo);
        for i:=1 to 8 do
           begin
           StringGrid2.Cells[i,0]:=IntToStr(i);
           end;
        iMask:=1;
        For j:=1 to 8 do
           begin
           StringGrid2.Font.Color:=clBlack;
           iBit:=iout and iMask;     {iBit:=iRelays[iRunNo] and iMask;}
           if (iBit=0) then
               begin
               StringGrid2.Cells[j,1]:='OFF';
               end
           else
               begin
               StringGrid2.Cells[j,1]:='ON';
               end;
           iMask:=iMask * 2;
           end;
        sFlt:=iTime;
        sFlt:=sFlt / 10;
        TxtBox101.Text:=Format('%8.1f',[sFlt]);
        end;

end;

procedure TMainForm.StringGrid1DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
 i,j,k,iMask,iBit:integer;
 OldColor:TColor;
 OldBrush:TBrush;
begin
     OldBrush:=StringGrid1.Canvas.Brush;
     OldColor:=StringGrid1.Font.Color;
     i:=ACol;
        j:=ARow;
        k:=iStart;
        if (StringGrid1.Cells[i,j]='ON') then
            begin
            StringGrid1.Canvas.Brush.Color:=clRed;
            StringGrid1.Canvas.FillRect(Rect);
            StringGrid1.Font.Color:=clBlack;
            StringGrid1.Canvas.TextOut(Rect.Left+2,Rect.Top+2,StringGrid1.Cells[i,j]);
            end
        else
            begin
            if (StringGrid1.Cells[i,j]='OFF') then
                begin
                StringGrid1.Canvas.Brush.Color:=clGreen;
                StringGrid1.Canvas.FillRect(Rect);
                StringGrid1.Font.Color:=clBlack;
                StringGrid1.Canvas.TextOut(Rect.Left+2,Rect.Top+2,StringGrid1.Cells[i,j]);
                end
            else
                begin
                StringGrid1.Canvas.Brush:=OldBrush;
                StringGrid1.Canvas.FillRect(Rect);
                StringGrid1.Font.Color:=OldColor;
                StringGrid1.Canvas.TextOut(Rect.Left+2,Rect.Top+2,StringGrid1.Cells[i,j]);
                end;
            end;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
     Close;
end;

procedure TMainForm.New1Click(Sender: TObject);
var
        I:Integer;
begin
        For i:=1 to MaxIndex do
                begin
                IInterval[I]:=0;
                IRelays[i]:=0;
                end;
        DisplayRelays();
end;

{===========================================================
Communication Functions}
function TMainForm.OpenComm(ID,InQueue, OutQueue, Baud,iDB ,Par,Stp: LongInt): Boolean;

begin
     Serial1.Close();
  case ID of
     1: Serial1.Port:= spCOM1;
     2: Serial1.Port:= spCOM2;
     3: Serial1.Port:= spCOM3;
     4: Serial1.Port:= spCOM4;
     5: Serial1.Port:= spCOM5;
     6: Serial1.Port:= spCOM6;
     7: Serial1.Port:= spCOM7;
     8: Serial1.Port:= spCOM8;
     9: Serial1.Port:= spCOM9;
     10: Serial1.Port:= spCOM10;
     end;
     Serial1.InputBuffer:=InQueue;
     Serial1.OutputBuffer:=OutQueue;
     Serial1.Baudrate:=MainForm.Serial1.IntToBaudRate(Baud);

  case iDB of
       7: Serial1.DataWidth:=dw7Bits;
       8: Serial1.DataWidth:=dw8Bits;
       end;

  case Par Of
       0: Serial1.Parity:=pbNone;
       1: Serial1.Parity:=pbEven;
       2: Serial1.Parity:=pbOdd;
       3: Serial1.Parity:=pbMark;
       4: Serial1.Parity:=pbSpace;
  end;
  case Stp of
       1: Serial1.StopBits:=sb1Bit;
       2: Serial1.StopBits:=sb2Bits;
  end;
  {Serial1.Sendstring('Config Port')}
end;

procedure TMainForm.PortActivate;
var
   bP:Boolean;
begin
  Serial1.EnableDTROnOpen:=True;
  Serial1.EnableRTSOnOpen:=True;
  Serial1.Open();
  {TxtPort.Caption:='Active';
  TxtPort.Font.Color:=clGreen;}
  bSerialInit:=True;
  Serial1.Sendstring('Open Port')
end;

procedure TMainForm.CloseComm(ID:Integer);
begin
     if bSerialInit=True then
        begin
        Serial1.EnableDTROnOpen:=False;
        Serial1.EnableRTSOnOpen:=False;
        {TxtPort.Caption:='InActive';
        TxtPort.Font.Color:=clRed;  }
        bSerialInit:=False;
        Serial1.Close();
        end;

end;


function TMainForm.SendCommStr(S: String): Integer;
var
  Count: Integer;
  i:Integer;
  iLen:Integer;
  arrS:array [0..300] of char;
begin
     iLen:=Length(S);
     for Count := 1 to iLen do
         begin
         arrS[count-1]:=S[Count];
         end;

     if bSerialInit=True then
        begin
        Serial1.SendData(@arrS,iLen);
        end;
end;

procedure TMainForm.Comms1Click(Sender: TObject);
begin
        CommsForm.Show;
end;

procedure TMainForm.StringGrid2DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
 i,j,k,iMask,iBit:integer;
 OldColor:TColor;
 OldBrush:TBrush;
begin
     OldBrush:=StringGrid2.Canvas.Brush;
     OldColor:=StringGrid2.Font.Color;
     i:=ACol;
        j:=ARow;
        k:=iStart;
        if (StringGrid2.Cells[i,j]='ON') then
            begin
            StringGrid2.Canvas.Brush.Color:=clRed;
            StringGrid2.Canvas.FillRect(Rect);
            StringGrid2.Font.Color:=clBlack;
            StringGrid2.Canvas.TextOut(Rect.Left+2,Rect.Top+2,StringGrid2.Cells[i,j]);
            end
        else
            begin
            if (StringGrid2.Cells[i,j]='OFF') then
                begin
                StringGrid2.Canvas.Brush.Color:=clGreen;
                StringGrid2.Canvas.FillRect(Rect);
                StringGrid2.Font.Color:=clBlack;
                StringGrid2.Canvas.TextOut(Rect.Left+2,Rect.Top+2,StringGrid2.Cells[i,j]);
                end
            else
                begin
                StringGrid2.Canvas.Brush:=OldBrush;
                StringGrid2.Canvas.FillRect(Rect);
                StringGrid2.Font.Color:=OldColor;
                StringGrid2.Canvas.TextOut(Rect.Left+2,Rect.Top+2,StringGrid2.Cells[i,j]);
                end;
            end;

end;

procedure TMainForm.Load1Click(Sender: TObject);
var
   InFName:String;
   InFile:TextFile;
   i,j,k,m,n:Integer;
   DRecipe:integer;
   InString,SubStr,sStr:String;
   Index:Integer;
   sRecipe,sIndex,sOut,sInt:String;
begin
     If OpenDialog1.execute then
        begin
        InfName:=OpenDialog1.FileName;
        AssignFile(InFile,InFName);
        Reset(InFile);
        Readln(InFile,Instring);
        iRepeats:=StrToInt(Instring);
        TxtRepeat.Text:=IntToStr(iRepeats);
        Index:=1;
        while not Eof(Infile) do
            begin
            Readln(InFile,Instring);
            I:=Pos(' ',Instring);
            if I=2 then
                begin
                sRecipe:=Copy(Instring,1,1);
                DRecipe:=StrToInt(sRecipe);
                Delete(Instring,1,2);
                I:=Pos(' ',Instring);
                sIndex:=Copy(Instring,1,I-1);
                Index:=StrToInt(sIndex);
                Delete(Instring,1,I);
                I:=Pos(' ',Instring);
                sOut:=Copy(Instring,1,I-1);
                I:=Pos(' ',Instring);
                Delete(Instring,1,I);
                sInt:=Instring;
                IRelays[Index]:=StrToInt(sOut);
                IInterval[Index]:=StrToInt(sInt);
                Index:=Index+1;
                end;
            end;

        Closefile(InFile);
        DRecipe:=1;
        DisplayRelays();
        end;


end;

procedure TMainForm.Save1Click(Sender: TObject);
var
   OutFName:String;
   OutFile:TextFile;
   i,j:integer;
   Strs:String;
begin
    {ReadDisplay();}
    If SaveDialog1.execute then
        begin
        OutfName:=SaveDialog1.FileName;
        AssignFile(OutFile,OutFName);
        Rewrite(OutFile);
        ReadDisplay();
        iRepeats:=StrToInt(TxtRepeat.Text);
        Strs:=IntToStr(iRepeats);
        Writeln(OutFile,Strs);
        For i:=1 to MaxIndex do
                begin
                Strs:=IntToStr(1) + ' ' + Inttostr(i) + ' ';
                Strs:=Strs + IntToStr(IRelays[i])+ ' ' + IntToStr(IInterval[i]);
                Writeln(OutFile,Strs);
                end;
        end;
        Closefile(OutFile);




end;

procedure TMainForm.All16Click(Sender: TObject);
begin
    iRelays[iStart+15]:=255;
    DisplayRelays();

end;

procedure TMainForm.All17Click(Sender: TObject);
begin
    iRelays[iStart+16]:=255;
    DisplayRelays();

end;

procedure TMainForm.All18Click(Sender: TObject);
begin
    iRelays[iStart+17]:=255;
    DisplayRelays();

end;

procedure TMainForm.All19Click(Sender: TObject);
begin
    iRelays[iStart+18]:=255;
    DisplayRelays();

end;

procedure TMainForm.All20Click(Sender: TObject);
begin
    iRelays[iStart+19]:=255;
    DisplayRelays();

end;

procedure TMainForm.None16Click(Sender: TObject);
begin
    iRelays[iStart+15]:=0;
    DisplayRelays();

end;

procedure TMainForm.None17Click(Sender: TObject);
begin
    iRelays[iStart+16]:=0;
    DisplayRelays();

end;

procedure TMainForm.None18Click(Sender: TObject);
begin
    iRelays[iStart+17]:=0;
    DisplayRelays();

end;

procedure TMainForm.None19Click(Sender: TObject);
begin
    iRelays[iStart+18]:=0;
    DisplayRelays();

end;

procedure TMainForm.None20Click(Sender: TObject);
begin
    iRelays[iStart+19]:=0;
    DisplayRelays();

end;

procedure TMainForm.None7Click(Sender: TObject);
begin
     iRelays[iStart+6]:=0;
    DisplayRelays();

end;

procedure TMainForm.None8Click(Sender: TObject);
begin
    iRelays[iStart+7]:=0;
    DisplayRelays();

end;

procedure TMainForm.None9Click(Sender: TObject);
begin
    iRelays[iStart+8]:=0;
    DisplayRelays();

end;

procedure TMainForm.None10Click(Sender: TObject);
begin
    iRelays[iStart+9]:=0;
    DisplayRelays();

end;

procedure TMainForm.None11Click(Sender: TObject);
begin
    iRelays[iStart+10]:=0;
    DisplayRelays();

end;

procedure TMainForm.None12Click(Sender: TObject);
begin
    iRelays[iStart+11]:=0;
    DisplayRelays();

end;

procedure TMainForm.None13Click(Sender: TObject);
begin
    iRelays[iStart+12]:=0;
    DisplayRelays();

end;

procedure TMainForm.None14Click(Sender: TObject);
begin
    iRelays[iStart+13]:=0;
    DisplayRelays();

end;

procedure TMainForm.None15Click(Sender: TObject);
begin
    iRelays[iStart+14]:=0;
    DisplayRelays();

end;

end.
